unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, TurboSprite, BitmapSprite, DestinationSpriteMover,
  FireworkSprite, PolygonSprite, ColorPalette, Polygon, DibCanvas;

type
  TfrmMain = class(TForm)
    Button1: TButton;
    SpriteSurface1: TSpriteSurface;
    SpriteEngine1: TSpriteEngine;
    DestinationSpriteMover1: TDestinationSpriteMover;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button8: TButton;
    ColorPalette1: TColorPalette;
    bmsfAnimated: TBitmapSpriteFactory;
    bmfsStatic: TBitmapSpriteFactory;
    fwsf: TFireworkSpriteFactory;
    psf: TPolygonSpriteFactory;
    imSaturn: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure SpriteSurface1SpriteClick(Sender: TObject; ASprite: TSprite);
    procedure Button6Click(Sender: TObject);
    procedure SpriteEngine1Collision(Sender: TObject; Sprite1,
      Sprite2: TSprite);
    procedure Button8Click(Sender: TObject);
    procedure SpriteSurface1Resize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpriteSurface1BeforeSpriteRender(Sender: TObject;
      ACanvas: TCanvas; ADibCanvas: TDIBCanvas);
  private
    n: longint;
    dcSaturn: TDibCanvas;
  public
  end;

var
  frmMain: TfrmMain;

implementation

uses PolygonEditorForm;

{$R *.DFM}

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  Randomize;
  SpriteSurface1.Active := not SpriteSurface1.Active;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  SpriteEngine1.AddSprite( bmfsStatic.CreateSprite );
end;

procedure TfrmMain.Button3Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to SpriteEngine1.SpriteCount - 1 do
    DestinationSpriteMover1.Destination[SpriteEngine1.Sprites[i]] := Point( Random( SpriteSurface1.VirtualWidth ), Random( SpriteSurface1.VirtualHeight ) );
end;

procedure TfrmMain.Button4Click(Sender: TObject);
var
  isp: TBitmapSprite;
begin
  isp := TBitmapSprite( bmsfAnimated.CreateSprite );
  isp.AnimationInterval := Random( 20 );
  if Random( 100 ) > 50 then
    isp.AnimationDirection := dirBackward;
  SpriteEngine1.AddSprite( isp );
end;

procedure TfrmMain.Button5Click(Sender: TObject);
begin
  SpriteEngine1.AddSprite( fwsf.CreateSprite );
end;

procedure TfrmMain.SpriteSurface1SpriteClick(Sender: TObject;
  ASprite: TSprite);
begin
  showMessage( 'Sprite Clicked!' );
end;

procedure TfrmMain.Button6Click(Sender: TObject);
begin
  SpriteEngine1.RemoveAllSprites;
end;

procedure TfrmMain.SpriteEngine1Collision(Sender: TObject; Sprite1,
  Sprite2: TSprite);
begin
  Inc( n );
  Caption := IntToStr( n );
end;

procedure TfrmMain.Button8Click(Sender: TObject);
var
  ps: TPolygonSprite;
begin
  ps := TPolygonSprite( psf.CreateSprite );
  ps.FillColorIndex := Random( 256 );
  ps.Filled := Random( 100 ) > 50;
  ps.SpinDirection := TDirection( Random( 2 ) );
  if Random( 100 ) > 50 then
    ps.SpinSPeed := Random * 2;
  SpriteEngine1.AddSprite( ps );
end;

procedure TfrmMain.SpriteSurface1Resize(Sender: TObject);
begin
  Caption := IntToStr( SPriteSurface1.VirtualWidth ) + ',' + IntToStr( SpriteSurface1.VirtualHeight );
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  dcSaturn := TDibCanvas.Create( imSaturn.Picture.Bitmap );
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  dcSaturn.Free;
end;

procedure TfrmMain.SpriteSurface1BeforeSpriteRender(Sender: TObject;
  ACanvas: TCanvas; ADibCanvas: TDIBCanvas);
begin
  ADibCanvas.Draw( 0, 0, dcSaturn );
end;

end.
